## mlpack 4.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(mlpack C CXX)

include(CMake/CheckHash.cmake)
include(CMake/Autodownload.cmake)
include(CMake/ConfigureCrossCompile.cmake)
include(CMake/CheckAtomic.cmake)

# First, define all the compilation options.
# We default to debugging mode for developers.
option(DEBUG "Compile with debugging information." OFF)
option(PROFILE "Compile with profiling information." OFF)
option(ARMA_EXTRA_DEBUG "Compile with extra Armadillo debugging symbols." OFF)
option(TEST_VERBOSE "Run test cases with verbose output." OFF)
option(BUILD_TESTS "Build tests. (Note: time consuming!)" OFF)
option(BUILD_CLI_EXECUTABLES "Build command-line executables." ON)
option(DOWNLOAD_DEPENDENCIES "Automatically download dependencies if not available." OFF)
option(BUILD_GO_SHLIB "Build Go shared library." OFF)
option(USE_PRECOMPILED_HEADERS "Use precompiled headers for mlpack_test build." ON)

# Set minimum library versions required by mlpack.
#
# For Armadillo, try to keep the minimum required version less than or equal to
# what's available on the current Ubuntu LTS or most recent stable RHEL release.
# See https://github.com/mlpack/mlpack/issues/3033 for some more discussion.
set(ARMADILLO_VERSION "10.8")
set(ENSMALLEN_VERSION "2.10.0")
set(CEREAL_VERSION "1.1.2")

# If BUILD_SHARED_LIBS is OFF then the mlpack library will be built statically.
# In addition, all mlpack CLI bindings will be linked statically as well.
if (WIN32)
  option(BUILD_SHARED_LIBS
      "Compile shared objects for tests and bindings (if OFF, static libraries and binaries are compiled)." OFF)

  set(DLL_COPY_DIRS "" CACHE STRING "List of directories (separated by ';') containing DLLs to copy for runtime.")
  set(DLL_COPY_LIBS "" CACHE STRING "List of DLLs (separated by ';') that should be copied for runtime.")
elseif(CMAKE_CROSSCOMPILING)
  option(BUILD_SHARED_LIBS
      "Compile shared libraries (if OFF, static libraries and binaries are compiled)." OFF)
else()
  option(BUILD_SHARED_LIBS
      "Compile shared objects for tests and bindings (if OFF, static libraries and binaries are compiled)." ON)
endif()

# Enable auto-download if we are cross compiling.
if (CMAKE_CROSSCOMPILING)
  set(DOWNLOAD_DEPENDENCIES ON)
endif()

# Support preference of static libs by adjusting CMAKE_FIND_LIBRARY_SUFFIXES.
if (NOT BUILD_SHARED_LIBS)
  if(WIN32)
    list(INSERT CMAKE_FIND_LIBRARY_SUFFIXES 0 .lib .a)
  else()
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a)
  endif()
endif()

# Detect whether the user passed BUILD_PYTHON_BINDINGS in order to determine if
# we should fail if Python isn't found.
if (BUILD_PYTHON_BINDINGS)
  set(FORCE_BUILD_PYTHON_BINDINGS ON)
else()
  set(FORCE_BUILD_PYTHON_BINDINGS OFF)
endif()
option(BUILD_PYTHON_BINDINGS "Build Python bindings." OFF)

# Detect whether the user passed BUILD_JULIA_BINDINGS in order to determine if
# we should fail if Julia isn't found.
if (BUILD_JULIA_BINDINGS)
  set(FORCE_BUILD_JULIA_BINDINGS ON)
else()
  set(FORCE_BUILD_JULIA_BINDINGS OFF)
endif()
option(BUILD_JULIA_BINDINGS "Build Julia bindings." OFF)

# Detect whether the user passed BUILD_GO_BINDINGS in order to determine if
# we should fail if Go isn't found.
if (BUILD_GO_BINDINGS)
  set(FORCE_BUILD_GO_BINDINGS ON)
else()
  set(FORCE_BUILD_GO_BINDINGS OFF)
endif()
option(BUILD_GO_BINDINGS "Build Go bindings." OFF)

# If building Go bindings then build go shared libraries.
if (BUILD_GO_BINDINGS)
  set(BUILD_GO_SHLIB ON)
endif()

# Detect whether the user passed BUILD_R_BINDINGS in order to determine if
# we should fail if R isn't found.
if (BUILD_R_BINDINGS)
  set(FORCE_BUILD_R_BINDINGS ON)
else()
  set(FORCE_BUILD_R_BINDINGS OFF)
endif()
option(BUILD_R_BINDINGS "Build R bindings." OFF)
# Build Markdown bindings for documentation.  This is used as part of website
# generation.
option(BUILD_MARKDOWN_BINDINGS "Build Markdown bindings for website documentation." OFF)

option(MATHJAX
    "Use MathJax for HTML Doxygen output (disabled by default)." OFF)
option(USE_OPENMP "If available, use OpenMP for parallelization." ON)
enable_testing()

# Set required standard to C++17.
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Ensure that GCC is new enough, if the compiler is GCC.
if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 8)
  message(FATAL_ERROR "GCC version (${CMAKE_CXX_COMPILER_VERSION}) is too old! 8.x or newer is required.")
endif ()

# Include modules in the CMake directory.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

# If we are not using Visual Studio, use the GNU install directories module.
# Otherwise set the values manually.
if (NOT MSVC)
  include(GNUInstallDirs)
else ()
  set(CMAKE_INSTALL_BINDIR ${CMAKE_INSTALL_PREFIX}/bin)
  set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_PREFIX}/lib)
  set(CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_PREFIX}/man)
  set(CMAKE_INSTALL_DOCDIR ${CMAKE_INSTALL_PREFIX}/share/doc/mlpack)
  set(CMAKE_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/include)
endif ()

# This is as of yet unused.
# option(PGO "Use profile-guided optimization if not a debug build" ON)

# Set the CFLAGS and CXXFLAGS depending on the options the user specified.
# Only GCC-like compilers support -Wextra, and other compilers give tons of
# output for -Wall, so only -Wall and -Wextra on GCC.
if (CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  # Ensure that we can't compile with clang 3.4, since this causes strange
  # issues.
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.5)
    message(FATAL_ERROR "mlpack does not build correctly with clang < 3.5.  "
        "Please upgrade your compiler and reconfigure mlpack.")
  endif ()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -ftemplate-depth=1000")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra")

  # To remove unused functions warnings.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-function")
endif()

# Check if atomics need -latomic linking.
#include(CheckAtomic)
if (NOT HAVE_CXX_ATOMICS_WITHOUT_LIB AND
    NOT HAVE_CXX_ATOMICS64_WITHOUT_LIB AND
    NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -latomic")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -latomic")
endif ()

# If we are using MSVC, we need /bigobj.
if (MSVC)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /Zc:__cplusplus")
endif ()

# If we are using MINGW, we need sections and big-obj, otherwise we create too
# many sections.
if (CMAKE_COMPILER_IS_GNUCC AND WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wa,-mbig-obj")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wa,-mbig-obj")
endif()

# If using clang, we have to link against libc++ depending on the
# OS (at least on some systems). Further, gcc sometimes optimizes calls to
# math.h functions, making -lm unnecessary with gcc, but it may still be
# necessary with clang.
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if (APPLE)
    # Detect OS X version. Use '/usr/bin/sw_vers -productVersion' to
    # extract V from '10.V.x'.
    exec_program(/usr/bin/sw_vers ARGS
        -productVersion OUTPUT_VARIABLE MACOSX_VERSION_RAW)
    string(REGEX REPLACE
        "([0-9]+)(\\.([0-9]+).*)*" "\\1"
        MACOSX_MAJOR_VERSION
        "${MACOSX_VERSION_RAW}")

    string(REGEX REPLACE
        "([0-9]+)(\\.([0-9]+).*)*" "\\3"
        MACOSX_MINOR_VERSION
        "${MACOSX_VERSION_RAW}")

     # OSX Lion (10.7) and OS X Mountain Lion (10.8) doesn't automatically
     # select the right stdlib.
    if (${MACOSX_MAJOR_VERSION} LESS 11 AND ${MACOSX_MINOR_VERSION} LESS 9)
      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++")
      set(CMAKE_SHARED_LINKER_FLAGS
          "${CMAKE_SHARED_LINKER_FLAGS} -stdlib=libc++")
      set(CMAKE_MODULE_LINKER_FLAGS
          "${CMAKE_MODULE_LINKER_FLAGS} -stdlib=libc++")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
     endif()
  endif()

  # Link everything with -lm.
  set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} "m")
  # Use -pthread, but not on OS X.
  if (NOT APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
  endif ()
endif()

# If we're using gcc, then we need to link against pthreads to use std::thread,
# which we do in the tests.
if (CMAKE_COMPILER_IS_GNUCC)
  find_package(Threads)
  set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
endif()

# Debugging CFLAGS.  Turn optimizations off; turn debugging symbols on.
set (BFD_DL_AVAILABLE "NO")
if (DEBUG)
  if (NOT MSVC)
    add_definitions(-DDEBUG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 -ftemplate-backtrace-limit=0")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -g -O0")
  endif()

  # mlpack uses it's own mlpack::backtrace class based on Binary File Descriptor
  # <bfd.h> and linux Dynamic Loader <libdl.h> and more portable version in future
  if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    find_package(Bfd)
    find_package(LibDL)
    if (LIBBFD_FOUND AND LIBDL_FOUND)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -rdynamic")
      set(MLPACK_INCLUDE_DIRS ${MLPACK_INCLUDE_DIRS} ${LIBBFD_INCLUDE_DIRS}
          ${LIBDL_INCLUDE_DIRS})
      set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} ${LIBBFD_LIBRARIES}
          ${LIBDL_LIBRARIES})
      set(BFD_DL_AVAILABLE "YES")
    else()
      message(WARNING "No libBFD and/or libDL has been found!")
    endif()
  endif()
else()
  add_definitions(-DNDEBUG)
  if (NOT MSVC)
    if (NOT CMAKE_CROSSCOMPILING)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -O3")
    else()
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
    endif()
  else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /O3")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /O3")
  endif ()
endif()

# Profiling CFLAGS.  Turn profiling information on.
if (CMAKE_COMPILER_IS_GNUCC AND PROFILE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
endif()

# If the user asked for extra Armadillo debugging output, turn that on.
if (ARMA_EXTRA_DEBUG)
  add_definitions(-DARMA_EXTRA_DEBUG)
endif()

# Now, find the libraries we need to compile against.  Several variables can be
# set to manually specify the directory in which each of these libraries
# resides.
#   ARMADILLO_LIBRARY - location of libarmadillo.so / armadillo.lib
#   ARMADILLO_INCLUDE_DIR - directory containing <armadillo>
#   ARMADILLO_INCLUDE_DIRS - directories necessary for Armadillo includes
#   CEREAL_INCLUDE_DIR - include directory for cereal
#   ENSMALLEN_INCLUDE_DIR - include directory for ensmallen
#   STB_IMAGE_INCLUDE_DIR - include directory for STB image library
#   MATHJAX_ROOT - root of MathJax installation

# Download and compile OpenBLAS if we are cross compiling mlpack for a specific
# architecture. The function takes the version of OpenBLAS as variable.
if (CMAKE_CROSSCOMPILING)
  search_openblas(0.3.28)
endif()

if (NOT DOWNLOAD_DEPENDENCIES)
  find_package(Armadillo "${ARMADILLO_VERSION}" REQUIRED)
else()
  find_package(Armadillo "${ARMADILLO_VERSION}")
  if (NOT ARMADILLO_FOUND)
    if (NOT CMAKE_CROSSCOMPILING)
      find_package(BLAS QUIET)
      find_package(LAPACK QUIET)
      if (NOT BLAS_FOUND AND NOT LAPACK_FOUND)
        message(FATAL_ERROR "Can not find BLAS or LAPACK!  These are required for Armadillo.  Please install one of them---or install Armadillo---before installing mlpack.")
      endif()
    endif()
    get_deps(https://files.mlpack.org/armadillo-12.6.5.tar.gz armadillo armadillo-12.6.5.tar.gz)
    set(ARMADILLO_INCLUDE_DIR ${GENERIC_INCLUDE_DIR})
    find_package(Armadillo REQUIRED)
  endif()
endif()
# Include directories for the previous dependencies.
set(MLPACK_INCLUDE_DIRS ${MLPACK_INCLUDE_DIRS} ${ARMADILLO_INCLUDE_DIRS})
set(MLPACK_LIBRARIES ${MLPACK_LIBRARIES} ${ARMADILLO_LIBRARIES})

# Find stb_image.h and stb_image_write.h.

=== DESCRIPTION ===
Package: mlpack
Title: 'Rcpp' Integration for the 'mlpack' Library
Version: 4.5.1
Date: 2024-12-04
Authors@R: c(
    person("Yashwant", "Singh Parihar", email = "yashwantsingh.sngh@gmail.com", role = c("aut", "ctb", "cph")),
    person("Ryan", "Curtin", email = "ryan@ratml.org", role = c("aut", "ctb", "cph", "cre")),
    person("Dirk", "Eddelbuettel", email = "edd@debian.org", role = c("aut", "ctb", "cph")),
    person("James", "Balamuta", email = "james.balamuta@gmail.com", role = c("aut", "ctb", "cph")),
    person("Bill", "March", email = "march@gatech.edu", role = c("ctb", "cph")),
    person("Dongryeol", "Lee", email = "dongryel@cc.gatech.edu", role = c("ctb", "cph")),
    person("Nishant", "Mehta", email = "niche@cc.gatech.edu", role = c("ctb", "cph")),
    person("Parikshit", "Ram", email = "p.ram@gatech.edu", role = c("ctb", "cph")),
    person("James", "Cline", email = "james.cline@gatech.edu", role = c("ctb", "cph")),
    person("Sterling", "Peet", email = "sterling.peet@gatech.edu", role = c("ctb", "cph")),
    person("Matthew", "Amidon", email = "mamidon@gatech.edu", role = c("ctb", "cph")),
    person("Neil", "Slagle", email = "npslagle@gmail.com", role = c("ctb", "cph")),
    person("Ajinkya", "Kale", email = "kaleajinkya@gmail.com", role = c("ctb", "cph")),
    person("Vlad", "Grantcharov", email = "vlad321@gatech.edu", role = c("ctb", "cph")),
    person("Noah", "Kauffman", email = "notoriousnoah@gmail.com", role = c("ctb", "cph")),
    person("Rajendran", "Mohan", email = "rmohan88@gatech.edu", role = c("ctb", "cph")),
    person("Trironk", "Kiatkungwanglai", email = "trironk@gmail.com", role = c("ctb", "cph")),
    person("Patrick", "Mason", email = "patrick.s.mason@gmail.com", role = c("ctb", "cph")),
    person("Marcus", "Edel", email = "marcus.edel@fu-berlin.de", role = c("ctb", "cph")),
    person("Mudit", "Raj Gupta", email = "mudit.raaj.gupta@gmail.com", role = c("ctb", "cph")),
    person("Sumedh", "Ghaisas", email = "sumedhghaisas@gmail.com", role = c("ctb", "cph")),
    person("Michael", "Fox", email = "michaelfox99@gmail.com", role = c("ctb", "cph")),
    person("Siddharth", "Agrawal", email = "siddharth.950@gmail.com", role = c("ctb", "cph")),
    person("Saheb", "Motiani", email = "saheb210692@gmail.com", role = c("ctb", "cph")),
    person("Yash", "Vadalia", email = "yashdv@gmail.com", role = c("ctb", "cph")),
    person("Abhishek", "Laddha", email = "laddhaabhishek11@gmail.com", role = c("ctb", "cph")),
    person("Vahab", "Akbarzadeh", email = "v.akbarzadeh@gmail.com", role = c("ctb", "cph")),
    person("Andrew", "Wells", email = "andrewmw94@gmail.com", role = c("ctb", "cph")),
    person("Zhihao", "Lou", email = "lzh1984@gmail.com", role = c("ctb", "cph")),
    person("Udit", "Saxena", email = "saxenda.udit@gmail.com", role = c("ctb", "cph")),
    person("Stephen", "Tu", email = "tu.stephenl@gmail.com", role = c("ctb", "cph")),
    person("Jaskaran", "Singh", email = "jaskaranvirdi@ymail.com", role = c("ctb", "cph")),
    person("Hritik", "Jain", email = "hritik.jain.cse13@itbhu.ac.in", role = c("ctb", "cph")),
    person("Vladimir", "Glazachev", email = "glazachev.vladimir@gmail.com", role = c("ctb", "cph")),
    person("QiaoAn", "Chen", email = "kazenoyumechen@gmail.com", role = c("ctb", "cph")),
    person("Janzen", "Brewer", email = "jahabrewer@gmail.com", role = c("ctb", "cph")),
    person("Trung", "Dinh", email = "dinhanhtrung@gmail.com", role = c("ctb", "cph")),
    person("Tham", "Ngap Wei", email = "thamngapwei@gmail.com", role = c("ctb", "cph")),
    person("Grzegorz", "Krajewski", email = "krajekg@gmail.com", role = c("ctb", "cph")),
    person("Joseph", "Mariadassou", email = "joe.mariadassou@gmail.com", role = c("ctb", "cph")),
    person("Pavel", "Zhigulin", email = "pashaworking@gmail.com", role = c("ctb", "cph")),
    person("Andy", "Fang", email = "AndyFang.DZ@gmail.com", role = c("ctb", "cph")),
    person("Barak", "Pearlmutter", email = "barak+git@pearlmutter.net", role = c("ctb", "cph")),
    person("Ivari", "Horm", email = "ivari@risk.ee", role = c("ctb", "cph")),
    person("Dhawal", "Arora", email = "d.p.arora1@gmail.com", role = c("ctb", "cph")),
    person("Alexander", "Leinoff", email = "alexander-leinoff@uiowa.edu", role = c("ctb", "cph")),
    person("Palash", "Ahuja", email = "abhor902@gmail.com", role = c("ctb", "cph")),
    person("Yannis", "Mentekidis", email = "mentekid@gmail.com", role = c("ctb", "cph")),
    person("Ranjan", "Mondal", email = "ranjan.rev@gmail.com", role = c("ctb", "cph")),
    person("Mikhail", "Lozhnikov", email = "lozhnikovma@gmail.com", role = c("ctb", "cph")),
    person("Marcos", "Pividori", email = "marcos.pividori@gmail.com", role = c("ctb", "cph")),
    person("Keon", "Kim", email = "kwk236@gmail.com", role = c("ctb", "cph")),
    person("Nilay", "Jain", email = "nilayjain13@gmail.com", role = c("ctb", "cph")),
    person("Peter", "Lehner", email = "peter.lehner@dlr.de", role = c("ctb", "cph")),
    person("Anuraj", "Kanodia", email = "akanuraj200@gmail.com", role = c("ctb", "cph")),
    person("Ivan", "Georgiev", email = "ivan@jonan.info", role = c("ctb", "cph")),
    person("Shikhar", "Bhardwaj", email = "shikharbhardwaj68@gmail.com", role = c("ctb", "cph")),
    person("Yashu", "Seth", email = "yashuseth2503@gmail.com", role = c("ctb", "cph")),
    person("Mike", "Izbicki", email = "mike@izbicki.me", role = c("ctb", "cph")),
    person("Sudhanshu", "Ranjan", email = "sranjan.sud@gmail.com", role = c("ctb", "cph")),
    person("Piyush", "Jaiswal", email = "piyush.jaiswal@st.niituniversity.in", role = c("ctb", "cph")),
    person("Dinesh", "Raj", email = "dinu.iota@gmail.com", role = c("ctb", "cph")),
    person("Vivek", "Pal", email = "vivekpal.dtu@gmail.com", role = c("ctb", "cph")),
    person("Prasanna", "Patil", email = "prasannapatil08@gmail.com", role = c("ctb", "cph")),
    person("Lakshya", "Agrawal", email = "zeeshan.lakshya@gmail.com", role = c("ctb", "cph")),
    person("Praveen", "Ch", email = "chvsp972911@gmail.com", role = c("ctb", "cph")),
    person("Kirill", "Mishchenko", email = "ki.mishchenko@gmail.com", role = c("ctb", "cph")),
    person("Abhinav", "Moudgil", email = "abhinavmoudgil95@gmail.com", role = c("ctb", "cph")),
    person("Thyrix", "Yang", email = "thyrixyang@gmail.com", role = c("ctb", "cph")),
    person("Sagar", "B Hathwar", email = "sagarbhathwar@gmail.com", role = c("ctb", "cph")),
    person("Nishanth", "Hegde", email = "hegde.nishanth@gmail.com", role = c("ctb", "cph")),
    person("Parminder", "Singh", email = "parmsingh101@gmail.com", role = c("ctb", "cph")),
    person("CodeAi", "", email = "benjamin.bales@assrc.us", role = c("ctb", "cph")),
    person("Franciszek", "Stokowacki", email = "franek.stokowacki@gmail.com", role = c("ctb", "cph")),
    person("Samikshya", "Chand", email = "samikshya289@gmail.com", role = c("ctb", "cph")),
    person("N", "Rajiv Vaidyanathan", email = "rajivvaidyanathan4@gmail.com", role = c("ctb", "cph")),
    person("Kartik", "Nighania", email = "kartiknighania@gmail.com", role = c("ctb", "cph")),
    person("Eugene", "Freyman", email = "evg.freyman@gmail.com", role = c("ctb", "cph")),
    person("Manish", "Kumar", email = "manish887kr@gmail.com", role = c("ctb", "cph")),
    person("Haritha", "Sreedharan Nair", email = "haritha1313@gmail.com", role = c("ctb", "cph")),
    person("Sourabh", "Varshney", email = "sourabhvarshney111@gmail.com", role = c("ctb", "cph")),
    person("Projyal", "Dev", email = "projyal@gmail.com", role = c("ctb", "cph")),
    person("Nikhil", "Goel", email = "nikhilgoel199797@gmail.com", role = c("ctb", "cph")),
    person("Shikhar", "Jaiswal", email = "jaiswalshikhar87@gmail.com", role = c("ctb", "cph")),
    person("B", "Kartheek Reddy", email = "bkartheekreddy@gmail.com", role = c("ctb", "cph")),
    person("Atharva", "Khandait", email = "akhandait45@gmail.com", role = c("ctb", "cph")),
    person("Wenhao", "Huang", email = "wenhao.huang.work@gmail.com", role = c("ctb", "cph")),
    person("Roberto", "Hueso", email = "robertohueso96@gmail.com", role = c("ctb", "cph")),
    person("Prabhat", "Sharma", email = "prabhatsharma7298@gmail.com", role = c("ctb", "cph")),
    person("Tan", "Jun An", email = "yamidarkxxx@gmail.com", role = c("ctb", "cph")),
    person("Moksh", "Jain", email = "mokshjn00@gmail.com", role = c("ctb", "cph")),
    person("Manthan-R-Sheth", "", email = "manthanrsheth96@gmail.com", role = c("ctb", "cph")),
    person("Namrata", "Mukhija", email = "namratamukhija@gmail.com", role = c("ctb", "cph")),
    person("Conrad", "Sanderson", role = c("ctb", "cph")),
    person("Thanasis", "Mattas", email = "mattasa@auth.gr", role = c("ctb", "cph")),
    person("Shashank", "Shekhar", email = "contactshashankshekhar@gmail.com", role = c("ctb", "cph")),
    person("Yasmine", "Dumouchel", email = "yasmine.dumouchel@gmail.com", role = c("ctb", "cph")),
    person("German", "Lancioni", role = c("ctb", "cph")),
    person("Arash", "Abghari", email = "arash.abghari@gmail.com", role = c("ctb", "cph")),
    person("Ayush", "Chamoli", role = c("ctb", "cph")),
    person("Tommi", "Laivamaa", email = "tommi.laivamaa@protonmail.com", role = c("ctb", "cph")),
    person("Kim", "SangYeon", email = "sy0814k@gmail.com", role = c("ctb", "cph")),
    person("Niteya", "Shah", email = "niteya.56@gmail.com", role = c("ctb", "cph")),
    person("Toshal", "Agrawal", email = "tagrawal1339@gmail.com", role = c("ctb", "cph")),
    person("Dan", "Timson", role = c("ctb", "cph")),
    person("Miguel", "Canteras", email = "mcanteras@gmail.com", role = c("ctb", "cph")),
    person("Bishwa", "Karki", email = "karkeebishwa1@gmail.com", role = c("ctb", "cph")),
    person("Mehul", "Kumar Nirala", email = "mehulkumarnirala@gmail.com", role = c("ctb", "cph")),
    person("Heet", "Sankesara", email = "heetsankesara3@gmail.com", role = c("ctb", "cph")),
    person("Jeffin", "Sam", email = "sam.jeffin@gmail.com", role = c("ctb", "cph")),
    person("Vikas", "S Shetty", email = "shettyvikas209@gmail.com", role = c("ctb", "cph")),
    person("Khizir", "Siddiqui", email = "khizirsiddiqui@gmail.com", role = c("ctb", "cph")),
    person("Tejasvi", "Tomar", email = "tstomar@outlook.com", role = c("ctb", "cph")),
    person("Jai", "Agarwal", email = "jai.bhageria@gmail.com", role = c("ctb", "cph")),
    person("Ziyang", "Jiang", email = "zij004@alumni.stanford.edu", role = c("ctb", "cph")),
    person("Rohit", "Kartik", email = "rohit.audrey@gmail.com", role = c("ctb", "cph")),
    person("Aditya", "Viki", email = "adityaviki01@gmail.com", role = c("ctb", "cph")),
    person("Kartik", "Dutt", email = "kartikdutt@live.in", role = c("ctb", "cph")),
    person("Suryoday", "Basak", email = "suryodaybasak@gmail.com", role = c("ctb", "cph")),
    person("Sriram", "S K", email = "sriramsk1999@gmail.com", role = c("ctb", "cph")),
    person("Manoranjan", "Kumar Bharti ( Nakul Bharti )", email = "knakul853@gmail.com", role = c("ctb", "cph")),
    person("Saraansh", "Tandon", email = "saraanshtandon1999@gmail.com", role = c("ctb", "cph")),
    person("Gaurav", "Singh", email = "gs8763076@gmail.com", role = c("ctb", "cph")),
    person("Lakshya", "Ojha", email = "ojhalakshya@gmail.com", role = c("ctb", "cph")),
    person("Bisakh", "Mondal", email = "bisakhmondal00@gmail.com", role = c("ctb", "cph")),
    person("Benson", "Muite", email = "benson_muite@emailplus.org", role = c("ctb", "cph")),
    person("Sarthak", "Bhardwaj", email = "7sarthakbhardwaj@gmail.com", role = c("ctb", "cph")),
    person("Aakash", "Kaushik", email = "kaushikaakash7539@gmail.com", role = c("ctb", "cph")),
    person("Anush", "Kini", email = "anushkini@gmail.com", role = c("ctb", "cph")),
    person("Nippun", "Sharma", email = "inbox.nippun@gmail.com", role = c("ctb", "cph")),
    person("Rishabh", "Garg", email = "rishabhgarg108@gmail.com", role = c("ctb", "cph")),

=== src/mlpack/CMakeLists.txt ===
# Recurse into the bindings to do any necessary configuration there.
add_subdirectory(bindings)
# Recurse into methods/ to get the definitions of any bindings.
add_subdirectory(methods)

# If necessary, configure the tests.
if (BUILD_TESTS)
  add_subdirectory(tests)
else ()
  # Add convenience target to tell the user they need BUILD_TESTS if they try to
  # build mlpack_test.
  add_custom_target(mlpack_test
      ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/CMake/TestError.cmake)
endif ()

# At install time, we simply install the src/ directory to include/ (though we
# omit bindings/ and tests/).
install(FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/../mlpack.hpp"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
install(FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/base.hpp"
    # Note: config.hpp does not get installed from the source directory!
    # The configured version gets installed.
    "${CMAKE_CURRENT_SOURCE_DIR}/core.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/namespace_compat.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/prereqs.hpp"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mlpack/")
install(FILES "${CMAKE_BINARY_DIR}/include/mlpack/config-local.hpp"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/mlpack"
    RENAME "config.hpp")
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/core" DESTINATION
    "${CMAKE_INSTALL_INCLUDEDIR}/mlpack")
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/methods" DESTINATION
    "${CMAKE_INSTALL_INCLUDEDIR}/mlpack")

# Extract the version number.
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/core/util/version.hpp"
  VERSION_HPP_CONTENTS)
string(REGEX REPLACE ".*#define MLPACK_VERSION_MAJOR ([0-9]+).*" "\\1"
  MLPACK_VERSION_MAJOR "${VERSION_HPP_CONTENTS}")
string(REGEX REPLACE ".*#define MLPACK_VERSION_MINOR ([0-9]+).*" "\\1"
  MLPACK_VERSION_MINOR "${VERSION_HPP_CONTENTS}")
string(REGEX REPLACE ".*#define MLPACK_VERSION_PATCH [\"]?([0-9x]+)[\"]?.*"
  "\\1" MLPACK_VERSION_PATCH "${VERSION_HPP_CONTENTS}")

set(PACKAGE_VERSION
  "${MLPACK_VERSION_MAJOR}.${MLPACK_VERSION_MINOR}.${MLPACK_VERSION_PATCH}")

post_python_bindings()
post_julia_setup()
post_go_setup()

# If we are building R-bindings, we have to run some setup after we
# recurse into methods/.  If not, this macro is empty.
post_r_setup()

# If we are building Markdown documentation, we have to run some setup after we
# recurse into methods/.  If not, this function is empty.
post_markdown_setup()

=== src/mlpack/bindings/R/CMakeLists.txt ===
macro (not_found_return message)
  message(STATUS "${message}")
  macro (add_r_binding directory name)
    # Do nothing.
  endmacro ()

  macro (post_r_setup)
    # Do nothing.
  endmacro ()

  return()
endmacro ()

# If we are not supposed to make R bindings, define the macro so it does
# nothing and leave this file.
if (NOT BUILD_R_BINDINGS)
  not_found_return("Not building R bindings.")
endif ()

if (BUILD_R_BINDINGS)

  # If mlpack upgrade the version of dependencies, then we also have to update the version here.
  set(RcppArmadillo_Version "0.${ARMADILLO_VERSION}")
  set(RcppEnsmallen_Version "0.${ENSMALLEN_VERSION}")

  # Import find_r_module.
  include(${CMAKE_SOURCE_DIR}/CMake/FindRModule.cmake)
  find_package(R 4.0)
  if (NOT R_FOUND)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - R")
  endif ()
  find_r_module(roxygen2)
  if (NOT R_ROXYGEN2)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - roxygen2")
  endif ()
  find_r_module(Rcpp 0.12.12)
  if (NOT R_RCPP)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - Rcpp")
  endif ()
  find_r_module(RcppArmadillo "${RcppArmadillo_Version}")
  if (NOT R_RCPPARMADILLO)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - RcppArmadillo")
  endif ()
  find_r_module(RcppEnsmallen "${RcppEnsmallen_Version}")
  if (NOT R_RCPPENSMALLEN)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - RcppEnsmallen")
  endif ()
  find_r_module(testthat)
  if (NOT R_TESTTHAT)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - testthat")
  endif ()
  find_r_module(pkgbuild) # Required for roxygen2 with src/ directories.
  if (NOT R_PKGBUILD)
    set(R_NOT_FOUND_MSG "${R_NOT_FOUND_MSG}\n    - pkgbuild")
  endif ()

  ## We need to check here if R and other dependencies is even available, as
  ## it is require to build R-bindings.
  if (FORCE_BUILD_R_BINDINGS)
    if (NOT R_FOUND OR NOT R_RCPP OR NOT R_RCPPARMADILLO OR NOT R_RCPPENSMALLEN
        OR NOT R_ROXYGEN2 OR NOT R_TESTTHAT OR NOT R_PKGBUILD)
      unset(BUILD_R_BINDINGS CACHE)
      message(FATAL_ERROR "Could not Build R Bindings, Following modules are not available:${R_NOT_FOUND_MSG}")
    endif()
  else ()
    if (NOT R_FOUND OR NOT R_RCPP OR NOT R_RCPPARMADILLO OR NOT R_RCPPENSMALLEN
        OR NOT R_ROXYGEN2 OR NOT R_TESTTHAT OR NOT R_PKGBUILD)
      unset(BUILD_R_BINDINGS CACHE)
      not_found_return("Not building R bindings, Following modules are not available:${R_NOT_FOUND_MSG}")
    endif()
  endif ()

  add_custom_target(R ALL)

  # Now configure DESCRIPTION.
  file(READ "${CMAKE_SOURCE_DIR}/src/mlpack/core/util/version.hpp"
      VERSION_HPP_CONTENTS)
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MAJOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MAJOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_MINOR ([0-9]+).*" "\\1"
      MLPACK_VERSION_MINOR "${VERSION_HPP_CONTENTS}")
  string(REGEX REPLACE ".*#define MLPACK_VERSION_PATCH [\"]?([0-9x]+)[\"]?.*"
      "\\1" MLPACK_VERSION_PATCH "${VERSION_HPP_CONTENTS}")
  set(PACKAGE_VERSION
      "${MLPACK_VERSION_MAJOR}.${MLPACK_VERSION_MINOR}.${MLPACK_VERSION_PATCH}")
  if (USING_GIT)
    set(PACKAGE_DOC_VERSION "git")
  else ()
    set(PACKAGE_DOC_VERSION "${PACKAGE_VERSION}")
  endif ()

  string(TIMESTAMP PACKAGE_DATE "%Y-%m-%d")

  # We need to generate an Authors@R list using every single contributor in
  # COPYRIGHT.txt.  That takes a little bit of processing.
  file(READ "${CMAKE_SOURCE_DIR}/COPYRIGHT.txt" COPYRIGHT_TXT_CONTENTS)
  string(REGEX MATCHALL "  Copyright [0-9-]*, ([^\n]*)\n" CONTRIBUTORS_LIST
      "${COPYRIGHT_TXT_CONTENTS}")

  # These are the authors meant to be listed as 'authors' and not
  # 'contributors'.  If you contributed specifically to the R bindings, you
  # should probably be listed here, so if you're not, open a PR to fix it! :)
  set(SPECIAL_AUTHORS "Yashwant Singh Parihar" "Ryan Curtin" "Dirk Eddelbuettel"
      "James Balamuta")

  string(CONCAT AUTHORS_R "c(\n"
      "    person(\"Yashwant\", \"Singh Parihar\", "
              "email = \"yashwantsingh.sngh@gmail.com\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),\n"
      "    person(\"Ryan\", \"Curtin\", email = \"ryan@ratml.org\", "
              "role = c(\"aut\", \"ctb\", \"cph\", \"cre\")),\n"
      "    person(\"Dirk\", \"Eddelbuettel\", email = \"edd@debian.org\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),\n"
      "    person(\"James\", \"Balamuta\", "
              "email = \"james.balamuta@gmail.com\", "
              "role = c(\"aut\", \"ctb\", \"cph\")),")
  foreach (CONTRIBUTOR_LINE ${CONTRIBUTORS_LIST})
    # Strip 'Copyright XXXX-YYYY, '.
    string(REGEX REPLACE "^  Copyright [0-9-]*, (.*)\n$" "\\1"
        CONTRIBUTOR_FILTERED "${CONTRIBUTOR_LINE}")

    # Extract the email if it exists.
    string(REGEX MATCH "^[^<]*<(.*)>.*$" HAS_EMAIL "${CONTRIBUTOR_FILTERED}")

    # The first name is just the first space-delimited word.  (That may not
    # always be right, but we have no way to know what is a first name and last
    # name and therefore must assume.)
    string(REGEX REPLACE "^([^ ]*) .*$" "\\1" CONTRIBUTOR_FIRST_NAME
        "${CONTRIBUTOR_FILTERED}")

    # Extracting the last name is just the rest of the tokens, but the regex is
    # different depending on whether we managed to get an email.
    if (HAS_EMAIL)
      string(REGEX REPLACE "^[^<]*<(.*)>.*$" "\\1" CONTRIBUTOR_EMAIL
          "${CONTRIBUTOR_FILTERED}")
      string(REGEX MATCH "^[^ ]* (.*) <.*$" CONTRIBUTOR_LAST_NAME
          "${CONTRIBUTOR_FILTERED}")
      if (NOT CONTRIBUTOR_LAST_NAME)
        set (CONTRIBUTOR_LAST_NAME "")
      else ()
        string(REGEX REPLACE "^[^ ]* (.*) <.*$" "\\1" CONTRIBUTOR_LAST_NAME
            "${CONTRIBUTOR_FILTERED}")
      endif ()

      # Skip anyone already listed as an author.
      if ("${CONTRIBUTOR_FIRST_NAME} ${CONTRIBUTOR_LAST_NAME}" IN_LIST
          SPECIAL_AUTHORS)
        continue()
      endif ()

      string(CONCAT AUTHORS_R "${AUTHORS_R}\n    "
          "person(\"${CONTRIBUTOR_FIRST_NAME}\", \"${CONTRIBUTOR_LAST_NAME}\", "
          "email = \"${CONTRIBUTOR_EMAIL}\", role = c(\"ctb\", \"cph\")),")

    else ()
      # No email is available.  So just get the last name.
      string(REGEX MATCH "^[^ ]* (.*)$" CONTRIBUTOR_LAST_NAME
          "${CONTRIBUTOR_FILTERED}")
      if (NOT CONTRIBUTOR_LAST_NAME)
        set (CONTRIBUTOR_LAST_NAME "")
      else ()
        string(REGEX REPLACE "^[^ ]* (.*)$" "\\1" CONTRIBUTOR_LAST_NAME
            "${CONTRIBUTOR_FILTERED}")
      endif ()

      # Skip anyone already listed as an author.
      if ("${CONTRIBUTOR_FIRST_NAME} ${CONTRIBUTOR_LAST_NAME}" IN_LIST
          SPECIAL_AUTHORS)
        continue()
      endif ()

      string(CONCAT AUTHORS_R "${AUTHORS_R}\n    "
          "person(\"${CONTRIBUTOR_FIRST_NAME}\", \"${CONTRIBUTOR_LAST_NAME}\", "
          "role = c(\"ctb\", \"cph\")),")
    endif ()
  endforeach ()
  # We also have to remove the final comma...
  string(REGEX REPLACE ",$" "" AUTHORS_R_OUT "${AUTHORS_R}")
  set(AUTHORS_R "${AUTHORS_R_OUT})")

  configure_file(${CMAKE_SOURCE_DIR}/src/mlpack/bindings/R/mlpack/DESCRIPTION.in
                 ${CMAKE_CURRENT_BINARY_DIR}/mlpack/DESCRIPTION
                 @ONLY)

  # Create the empty NAMESPACE file that will include all export functions.
  file(WRITE
      "${CMAKE_CURRENT_BINARY_DIR}/mlpack/NAMESPACE"
      "# Generated by roxygen2: do not edit by hand"
      "\n\n")

  set(CPP_SOURCES
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/r_util.cpp"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/rcpp_mlpack.h"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/Makevars"
   "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/src/Makevars.win"
  )

  set(R_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/R/matrix_utils.R"
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/R/package.R"
  )

  set(BINDINGS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/get_type.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc_functions.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_doc_functions_impl.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_input_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_printable_param.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/get_r_type.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_input_processing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_output_processing.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/print_serialize_util.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack_main.hpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/R_option.hpp"
  )

  set(TESTS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/tests/test_r_binding_main.cpp"
  )

  set(R_TESTTHAT_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/tests/testthat/test-R_binding.R"
  )

  set(R_TESTS_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/tests/testthat.R"
  )

  # Configure the license file.
  string(TIMESTAMP LICENSE_YEAR "%Y")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mlpack/LICENSE.in"
                 "${CMAKE_CURRENT_BINARY_DIR}/mlpack/LICENSE")

  add_custom_target(r_copy ALL)

  # First we have to create all the required directories for copy.
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/R/
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests/testthat
      COMMAND ${CMAKE_COMMAND} -E make_directory
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R/tests
   )

  if (BUILD_TESTS)
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${TESTS_SOURCES}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R/tests)
  endif()

  # Copy all necessary files for building package.
  foreach(cpp_file ${CPP_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${cpp_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/)
  endforeach()
  foreach(r_file ${R_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${r_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/R/)
  endforeach()
  foreach(bindings_file ${BINDINGS_SOURCES})
    add_custom_command(TARGET r_copy PRE_BUILD
        COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
            ${bindings_file}
            ${CMAKE_CURRENT_BINARY_DIR}/mlpack/src/mlpack/bindings/R)
  endforeach()
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
          ${R_TESTTHAT_SOURCES}
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests/testthat)
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different
          ${R_TESTS_SOURCES}
          ${CMAKE_CURRENT_BINARY_DIR}/mlpack/tests)
  # This file will take care of multiple definition of functions in .cpp files.
  add_custom_command(TARGET r_copy PRE_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E touch
          "${CMAKE_CURRENT_BINARY_DIR}/mlpack/model.txt")

  file(COPY
       "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/cleanup"
       DESTINATION
       "${CMAKE_CURRENT_BINARY_DIR}/mlpack/")

  file(COPY
       "${CMAKE_CURRENT_SOURCE_DIR}/mlpack/inst/CITATION"
       DESTINATION
       "${CMAKE_CURRENT_BINARY_DIR}/mlpack/inst")

  # Do the actual build.
  add_custom_target(r_build ALL)

  # "model.txt" is no longer useful, after generating src/.cpp files.
  # Remove this file.
  add_custom_command(TARGET r_build POST_BUILD
      COMMAND ${CMAKE_COMMAND} ARGS -E remove -f "model.txt"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/mlpack"
  )

  # Build RcppExports.cpp/.R, NAMESPACE and man/ files.
  add_custom_command(TARGET r_build POST_BUILD
      COMMAND ${RSCRIPT_EXECUTABLE} ARGS "-e" "'Rcpp::compileAttributes()'"
      COMMAND ${RSCRIPT_EXECUTABLE} ARGS "-e" "'roxygen2::roxygenize(\".\")'"

=== src/mlpack/bindings/cli/CMakeLists.txt ===
# This macro adds a command-line executable with the given name.  It assumes
# that the file with main() is in <name>_main.cpp, and produces an output
# program with the name mlpack_<name>.
macro (add_cli_executable directory name)
if (BUILD_CLI_EXECUTABLES)
  add_executable(mlpack_${name}
    ${directory}/${name}_main.cpp
  )
  # Build mlpack CLI binding binaries statically.
  if(NOT BUILD_SHARED_LIBS)
    target_link_libraries(mlpack_${name} -static
      ${MLPACK_LIBRARIES}
    )
  else()
    # Build mlpack CLI binding binaries dynamically.
    target_link_libraries(mlpack_${name}
      ${MLPACK_LIBRARIES}
    )
  endif()
  # Make sure that we set BINDING_TYPE to cli so the command-line program is
  # compiled with the correct int main() call.
  set_target_properties(mlpack_${name} PROPERTIES COMPILE_FLAGS
      -DBINDING_TYPE=BINDING_TYPE_CLI -DMLPACK_PRINT_INFO -DMLPACK_PRINT_WARN)
  install(TARGETS mlpack_${name} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

  # If man documentation is being generated, make sure this is a dependency.
  if (TXT2MAN)
    add_dependencies(man mlpack_${name})
  endif ()
endif ()
endmacro ()

=== debian/changelog ===
mlpack (4.5.1-1build2) plucky; urgency=medium

  * No-change rebuild against python3-numpy2-abi0

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 29 Jan 2025 22:32:22 +0000

mlpack (4.5.1-1build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 11:58:34 +0100

mlpack (4.5.1-1) unstable; urgency=medium

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 09 Dec 2024 14:42:18 +0000

=== debian/control ===
Source: mlpack
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Barak A. Pearlmutter <bap@debian.org>
Build-Depends: cmake, debhelper-compat (= 13),
		pkgconf,
		libcereal-dev,
		libarmadillo-dev,
		libensmallen-dev (>= 2.10.0),
		libstb-dev,
		dh-python, dh-sequence-python3,
		python3, python3-dev, python3-pandas, python3-numpy, cython3, python3-setuptools,
		python3-pytest-runner, python3-pip,
		txt2man,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.mlpack.org/
Vcs-Git: https://salsa.debian.org/science-team/mlpack.git
Vcs-Browser: https://salsa.debian.org/science-team/mlpack

Package: libmlpack-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
	 libensmallen-dev (>= 2.10.0),
	 libarmadillo-dev, liblapack-dev,
	 libcereal-dev
Recommends: libstb-dev
Suggests: mlpack-doc
Description: intuitive, fast, scalable C++ machine learning library (development libs)
 This package contains the mlpack Library development files.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: python3-mlpack
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends},
	 ${python3:Depends}
Description: intuitive, fast, scalable C++ machine learning library (Python bindings)
 This package contains Python bindings for the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a "swiss army knife" for machine learning
 researchers.

Package: mlpack-bin
Section: science
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: intuitive, fast, scalable C++ machine learning library (binaries)
 This package contains example binaries using the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a “swiss army knife” for machine learning
 researchers.

Package: mlpack-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libjs-jquery
Description: intuitive, fast, scalable C++ machine learning library (documentation)
 This package contains documentation for the mlpack Library.
 .
 Machine Learning Pack (mlpack) is an intuitive, fast, scalable C++
 machine learning library, meant to be a machine learning analog to
 LAPACK.  It aims to implement a wide array of machine learning
 methods and function as a “swiss army knife” for machine learning
 researchers.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# dh_python3 needs DEB_HOST_ARCH, so ... sledge hammer:
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export LIBS="pthread"
export DESTDIR=debian/tmp

## Memory consumption issues on some autobuilders have been causing
## build failures.  There are three ways to address such issues:
## (a) reduce parallelism, e.g., dh $@ --max-parallel=2
## (b) reduce GCC memory usage, e.g., g++ --param ggc-min-expand=20 to
## reduce abrupt memory spikes, and g++ -g0 to skip debugging info.
## (c) switch to clang.

## Force Compiler to CLANG if installed. Otherwise use GCC but try to
## conserve memory. The build dependencies try to install CLANG, but
## give a dummy alternative so the build can proceed even if it is
## unavailable.
## Note: this requires build dependencies of the form
##     clang [!alpha !hppa !ia64 !m68k !sh4 !x32],
##     libomp-dev [!alpha !hppa !ia64 !m68k !sh4 !x32],

# ifeq ($(shell type clang > /dev/null && echo found),found)
# export CC=clang
# export CXX=clang++
# else

## These issues have occurred post-2.1.x in two places: Ubuntu
## Launchpad, and some particular Debian architectures including
## armhf, mips, mipsel, m68k, kfreebsd-amd64, kfreebsd-i386.

## For that reason, I am activating all of the above space-reduction
## mechanisms on Ubuntu, all 32-bit architectures, and all kfreebsd
## systems. And I am setting the build to single threaded on all
## architectures.

DH_FLAGS += --max-parallel=1

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
SAVE_SPACE=yes
endif

ifeq ($(shell dpkg-architecture --query DEB_BUILD_ARCH_BITS),32)
SAVE_SPACE=yes
endif

ifeq ($(shell dpkg-architecture --query DEB_BUILD_ARCH_OS),kfreebsd)
SAVE_SPACE=yes
endif

ifeq ($(SAVE_SPACE),yes)
ifneq (, $(filter $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU),mips mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=5 -g0
else
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=20 -g0
endif
endif
# endif

DO_IT_TO_JULIA=OFF
TAKE_IT_TO_GO=OFF
WHY_R_WHY_NOT=OFF

%:
	dh $@ --without python2 --with python3 --buildsystem=cmake ${DH_FLAGS}

# ON or OFF
# Fails as of 4.2.0, "17 < 17"
BUILD_TESTS=OFF

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DDEBUG=ON \
		-DPROFILE=OFF \
		-DARMA_EXTRA_DEBUG=OFF \
		-DBUILD_CLI_EXECUTABLES=ON \
		-DBUILD_PYTHON_BINDINGS=ON \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
		-DBUILD_JULIA_BINDINGS=$(DO_IT_TO_JULIA) \
		-DBUILD_GO_BINDINGS=$(TAKE_IT_TO_GO) \
		-DBUILD_R_BINDINGS=$(WHY_R_WHY_NOT) \
		-DBUILD_TESTS=$(BUILD_TESTS) \
		-DBUILD_SHARED_LIBS=ON \
		-DDISABLE_DOWNLOADS=ON \
		-DSTB_IMAGE_INCLUDE_DIR=/usr/include/stb \
		-DUSE_OPENMP=ON

ifeq ($(BUILD_TESTS),OFF)
override_dh_auto_test:
	@echo "Build time testing disabled."
endif

execute_after_dh_python3:
	dh_numpy3

execute_after_dh_install:
	@echo "use shared jquery.js javascript library"
	for f in $$(find debian/mlpack-doc -name jquery.js); do \
	  ln --verbose --symbolic --force /usr/share/javascript/jquery/jquery.js $$f; \
	done
	@echo "remove byte-compiled python files per policy"
	-find debian/python-mlpack  -name '*.pyc' -ls -delete || true
	-find debian/python3-mlpack -name '*.pyc' -ls -delete || true
	@echo "remove extra license file"
	-rm --verbose debian/libmlpack-dev/usr/include/mlpack/core/std_backport/LICENSE.txt
	@echo "move stray documentation files into /usr/share/doc/"
	(test \! -d debian/libmlpack-dev || \
	(cd debian/libmlpack-dev && \
	 for f in $$(find usr/include -type f \! -name '*.hpp' \! -name '*.cpp'); do \
	   mkdir -p usr/share/doc/libmlpack-dev/$$(dirname $$f) && \
	   mv --verbose $$f usr/share/doc/libmlpack-dev/$$(dirname $$f)/; \
	 done))
	(test \! -d debian/python3-mlpack || \
	(cd debian/python3-mlpack && \
	 for f in $$(find usr/lib -type f -name '*.txt'); do \
	   mkdir -p usr/share/doc/python3-mlpack/$$(dirname $$f) && \
	   mv --verbose $$f usr/share/doc/python3-mlpack/$$(dirname $$f)/; \
	 done))

override_dh_installdocs:
	dh_installdocs -pmlpack-doc --doc-main-package libmlpack-dev
	dh_installdocs -Nmlpack-doc

override_dh_installexamples:
	dh_installexamples -pmlpack-doc --doc-main-package libmlpack-dev
	dh_installexamples -Nmlpack-doc

execute_after_dh_installexamples:
	@echo "Search and destroy stray VCS support files"
	-find debian/mlpack-doc -name .gitignore -ls -delete || true
	@echo "Remove empty directory"
	-rmdir debian/mlpack-doc/usr/share/doc/libmlpack-dev/examples/sample-ml-app/sample-ml-app/data/

override_dh_installchangelogs:
	dh_installchangelogs HISTORY.md
